/* file _prop.h */

/* NOTE: rcsc2 variable names and function names are truncated to 16 characters !! */

/* The following are the port latch and direction registers	*/
/* Their names are reserved					*/
/* These are mapped to SX physical ports and VM registers	*/
/* and must be present before any other variable		*/

/* 8bit ports (rc, rd and re are ram for SX18, rd and re are ram for SX28	*/
/* cpuflags is the VM flag register - do not write to it			*/
/* bit0-bit3	argument count, returned by ccargc()				*/
/* bit4		reserved							*/
/* bit5		carry								*/
/* bit6		interrupt enable						*/
/* bit7		return from interrupt						*/
#asm
DAT

  VM_AX		word	0		{{ primary register (pr)   }}
  VM_BX		word	0		{{ secondary register (sr) }}
  VM_CX		word	0		{{ auxiliary register #1   }}
  VM_DX		word	0		{{ auxiliary register #2   }}
  VM_PC		word	0		{{ program counter         }}
  VM_BP		word	0		{{ stack frame register    }}
  VM_SP		word	0		{{ stack pointer register  }}
  VM_PCODE	byte	0		{{ pseude code operator    }}
  VM_FLAGS	byte	0		{{ flags carry, zero       }}
  VM_STACK	byte	0[STACKSIZE]	{{ stack area              }}
#endasm

unsigned char ra0dir,ra1dir,ra2dir,ra3dir;
unsigned char ra0,ra1,ra2,ra3;

/* end of file _prop.h */
